#!c:/perl/bin/perl.exe
use warnings;
use strict;
use diagnostics;

## While Loops
my $count = 0;

while ($count < 10) {
	print "Count is $count\n";
	++$count;
}


## Foreach loops
# With named loop variable
foreach my $value (2,4,6,8,10) {
	print "Value is $value\n";
}

# Without a named loop variable (defaults to $_)
foreach (2,4,6,8,10) {
	print;
	print "\n";
}


# Looping through an array
my @animals = ("doggies","bunnies","kittens");

foreach my $animal (@animals) {
	print "I just love cute little $animal\n";
}


# Looping through the keys of a hash
my %test_scores = (
	Adam => 50,
	Joe => 30,
	Sarah => 40);

foreach my $person (keys %test_scores) {
	print "$person got a score of ",$test_scores{$person},"\n";
}

# Sorting as part of the loop
foreach my $person (sort {$a cmp $b} keys %test_scores) {
	print "$person got a score of ",$test_scores{$person},"\n";
}

# Using the range operator
foreach my $number (100..120) {
	print "$number is a very big number\n";
}

foreach my $letter ("a".."z","A".."Z") {
	print "I know the letter $letter\n";
}


## Loop control - next and last
# Next
my @days = ("Mon","Tue","Wed","Thur","Fri","Sat","Sun");

foreach my $day (@days) {
	next if ($day eq "Sun" or $day eq "Sat");
	print "Ho hum it's $day - time to go to work\n";
}


# Last
while (1) { # Infinite loop
	my $guess = int(rand(10));
	if ($guess==5) {
		print "You guessed!\n";
		last;
	}
	else {
		print "No, not $guess, try again!\n";
	}
}

## Nested Loops
YEARS: foreach my $year (2000..2005) {
	if (($year % 4) != 0) {		
		foreach my $month (1..12) {
			# I only work until July
			if ($month == 7) {
				print "Yippee, 6 months off!\n";
				next YEARS;
			}
			print "Suppose I'd better do some work in month $month of $year\n";
		}	
	}
	print "Ooh $year is a leapyear!\n";
}




