#!c:/perl/bin/perl.exe
use warnings;
use strict;
use diagnostics;

## Using references to pass arrays to subroutines
my @array1 = (1,2,3,4);
my @array2 = (5,6,7);

compare_arrays (\@array1,\@array2);

sub compare_arrays {

	my ($arrayref1,$arrayref2) = @_;
	
	if (@$arrayref1 > @$arrayref2) {
		print "First array was longer\n";
	}
	else {
		print "Second array was longer\n";
	}
}


## Dereferencing
my $arrayref = [10,20,30];
print "First element is ",$$arrayref[0],"\n";

my $hashref = {
	duck => 'quack',
};
print "The duck says ",$$hashref{duck},"\n";


## Clearer syntax for the same thing
print "First element is ",$arrayref->[0],"\n";

print "The duck says ",$hashref->{duck},"\n";



## Copying references
my $original = [2,4,6,8];
my $copy = $original;

for (0..(@$copy-1)){
	$copy->[$_] *= 10;
}

print "Copy says ",$copy->[1]," but original was ",$original->[1],"\n";


## Building complex data structures
my %countries = (
	uk => {
		population => 60441457,
		language => 'English',
		currency => 'Pounds',
	},
	
	france => {
		population => 60656178,
		language => 'French',
		currency => 'Euros',
	},
	
	ireland => {
		population => 4015676,
		language => 'English / Irish',
		currency => 'Euros',
	},
);

print "Population of France is ", $countries{france}->{population},"\n";



## Even more complex data strucutres
my @experiments = (
	{
		sample_id => 1,
		sample_name => 'kidney',
		sample_measures => [12,56,34,65,76],
	},
	{
		sample_id => 4,
		sample_name => 'liver',
		sample_measures => [24,66,12,17,26],
	},
		{
		sample_id => 26,
		sample_name => 'spleen',
		sample_measures => [85,93],
	},
);

foreach my $expt (@experiments) {
	print "The first measure for sample ",
		$expt->{sample_id},
		" (",$expt->{sample_name},") was ",
		$expt->{sample_measures}->[0],"\n";
}



