#!c:/perl/bin/perl.exe
use warnings;
use strict;
use diagnostics;

my @addresses = qw (
	www.ebi.ac.uk
	rscb.org
	seqanswers.com
);

foreach my $address (@addresses) {

	open (IN,"nslookup $address 2> NUL |") or die "Can't open pipe to nslookup: $!";
	
	# The start of the nslookup output is always
	# the name server details, so we want to 
	# skip everything up to the first blank
	# line
	
	while (<IN>) {
		chomp;
		last unless ($_);	
	}
	
	# Now we can read the real information and
	# look for the address
	while (<IN>) {
		chomp;
		if (/^Address:\s+(\S+)/) {
			print "$1\t$address\n";
			last;	
		}	
	}
	
}
